"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = buildPreset;

var _babelPresetEnv = require("babel-preset-env");

var _babelPresetEnv2 = _interopRequireDefault(_babelPresetEnv);

var _compiler = require("@mfjs/compiler");

var _builtIns = require("babel-preset-env/data/built-ins.json");

var _builtIns2 = _interopRequireDefault(_builtIns);

var _pluginFeatures = require("babel-preset-env/data/plugin-features");

var _pluginFeatures2 = _interopRequireDefault(_pluginFeatures);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const supportedPlugins = ["transform-regenerator", "transform-es2015-for-of", "transform-async-to-generator", "transform-es2015-classes", "transform-es2015-literals", "transform-es2015-parameters", "transform-es2015-sticky-regex", "transform-es2015-template-literals", "transform-es2015-typeof-symbol", "transform-es2015-unicode-regex", "transform-exponentiation-operator", "syntax-trailing-function-commas"];

const supported = supportedPlugins.concat(Object.keys(_builtIns2.default));
const supSet = new Set(supportedPlugins);
const notSupported = Object.keys(_pluginFeatures2.default).filter(i => !supSet.has(i));

function buildPreset(context, opts = {}) {
  const mfopts = opts.mfjs || {};
  delete opts.mfjs;
  const beforeOpts = Object.assign({}, opts, { include: notSupported,
    exclude: supported,
    modules: false });
  return {
    passPerPreset: true,
    presets: [(0, _babelPresetEnv2.default)(context, beforeOpts), (0, _compiler.babelPreset)(mfopts) /*,env(context,opts)*/]
  };
}